---
title: calc()
slug: Web/CSS/calc()
tags:
  - CSS
  - CSS Function
  - Calculate
  - Compute
  - Function
  - Layout
  - Reference
  - Web
  - calc
---
<div>{{CSSRef}}</div>

<p>The <strong><code>calc()</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Functions">function</a> lets you perform calculations when specifying CSS property values. It can be used anywhere a {{cssxref("&lt;length&gt;")}}, {{cssxref("&lt;frequency&gt;")}}, {{cssxref("&lt;angle&gt;")}}, {{cssxref("&lt;time&gt;")}}, {{cssxref("&lt;percentage&gt;")}}, {{cssxref("&lt;number&gt;")}}, or {{cssxref("&lt;integer&gt;")}} is allowed.</p>

<div>{{EmbedInteractiveExample("pages/css/function-calc.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css no-line-numbers notranslate">/* property: calc(expression) */
width: calc(100% - 80px);</pre>

<p>The <code>calc()</code> function takes a single expression as its parameter, with the expression's result used as the value. The expression can be any simple expression combining the following operators, using standard <a href="/en-US/docs/Learn/JavaScript/First_steps/Math#Operator_precedence">operator precedence rules</a>:</p>

<dl>
 <dt><code>+</code></dt>
 <dd>Addition.</dd>
 <dt><code>-</code></dt>
 <dd>Subtraction.</dd>
 <dt><code>*</code></dt>
 <dd>Multiplication. At least one of the arguments must be a {{cssxref("&lt;number&gt;")}}.</dd>
 <dt><code>/</code></dt>
 <dd>Division. The right-hand side must be a {{cssxref("&lt;number&gt;")}}.</dd>
</dl>

<p>The operands in the expression may be any {{cssxref("&lt;length&gt;")}} syntax value. You can use different units for each value in your expression, if you wish. You may also use parentheses to establish computation order when needed.</p>

<h3 id="Notes">Notes</h3>

<ul>
 <li>The <code>+</code> and <code>-</code> operators <strong>must be surrounded by whitespace</strong>. For instance, <code>calc(50% -8px)</code> will be parsed as a percentage followed by a negative length — an invalid expression — while <code>calc(50% - 8px)</code> is a percentage followed by a subtraction operator and a length. Likewise, <code>calc(8px + -50%)</code> is treated as a length followed by an addition operator and a negative percentage.</li>
 <li>The <code>*</code> and <code>/</code> operators do not require whitespace, but adding it for consistency is both allowed and recommended.</li>
 <li>Division by zero results in an error being generated by the HTML parser.</li>
 <li>Math expressions involving percentages for widths and heights on table columns, table column groups, table rows, table row groups, and table cells in both auto and fixed layout tables <em>may</em> be treated as if <code>auto</code> had been specified.</li>
 <li>It is permitted to nest <code>calc()</code> functions, in which case the inner ones are treated as simple parentheses.</li>
</ul>

<h3 id="Formal_syntax">Formal syntax</h3>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>When <code>calc()</code> is used for controlling text size, be sure that one of the values includes a <a href="/en-US/docs/Web/CSS/length#Relative_length_units">relative length unit</a>, for example:</p>

<pre class="brush: css notranslate">h1 {
  font-size: calc(1.5rem + 3vw);
}</pre>

<p>This ensures that text size will scale if the page is zoomed.</p>

<ul>
 <li><a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Perceivable#Guideline_1.4_Make_it_easier_for_users_to_see_and_hear_content_including_separating_foreground_from_background">MDN Understanding WCAG, Guideline 1.4 explanations</a></li>
 <li><a href="https://www.w3.org/TR/UNDERSTANDING-WCAG20/visual-audio-contrast-scale.html">Understanding Success Criterion 1.4.4 | W3C Understanding WCAG 2.0</a></li>
</ul>

<h2 id="Usage_with_integers">Usage with integers</h2>

<p>When <strong><code>calc()</code></strong> is used where an {{cssxref("&lt;integer&gt;")}} is expected, the value will be rounded to the nearest integer. For example:</p>

<pre class="brush: css notranslate">.modal {
  z-index: calc(3 / 2);
}</pre>

<p>This will give <code>.modal</code> a final <code>z-index</code> value of 2.</p>

<p><strong>Note:</strong> The Chrome browser currently won’t accept some values returned by <strong><code>calc()</code></strong> when an integer is expected. This includes any division, even if it results in an integer. ie. <code>z-index: calc(4 / 2);</code> will not be accepted.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Positioning_an_object_on_screen_with_a_margin">Positioning an object on screen with a margin</h3>

<p><code>calc()</code> makes it easy to position an object with a set margin. In this example, the CSS creates a banner that stretches across the window, with a 40-pixel gap between both sides of the banner and the edges of the window:</p>

<pre class="brush: css notranslate">.banner {
  position: absolute;
  left: 40px;
  width: calc(100% - 80px);
  border: solid black 1px;
  box-shadow: 1px 2px;
  background-color: yellow;
  padding: 6px;
  text-align: center;
  box-sizing: border-box;
}
</pre>

<pre class="brush: html notranslate">&lt;div class="banner"&gt;This is a banner!&lt;/div&gt;</pre>

<p>{{EmbedLiveSample('Positioning_an_object_on_screen_with_a_margin', 'auto', '60')}}</p>

<h3 id="Automatically_sizing_form_fields_to_fit_their_container">Automatically sizing form fields to fit their container</h3>

<p>Another use case for <code>calc()</code> is to help ensure that form fields fit in the available space, without extruding past the edge of their container, while maintaining an appropriate margin.</p>

<p>Let's look at some CSS:</p>

<pre class="brush: css notranslate">input {
  padding: 2px;
  display: block;
  width: calc(100% - 1em);
}

#formbox {
  width: calc(100% / 6);
  border: 1px solid black;
  padding: 4px;
}
</pre>

<p>Here, the form itself is established to use 1/6 of the available window width. Then, to ensure that input fields retain an appropriate size, we use <code>calc()</code> again to establish that they should be the width of their container minus 1em. Then, the following HTML makes use of this CSS:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;div id="formbox"&gt;
  &lt;label&gt;Type something:&lt;/label&gt;
  &lt;input type="text"&gt;
  &lt;/div&gt;
&lt;/form&gt;
</pre>

<p>{{EmbedLiveSample('Automatically_sizing_form_fields_to_fit_their_container', '700', '80')}}</p>

<h3 id="Nested_calc_with_CSS_Variables">Nested <code>calc()</code> with CSS Variables</h3>

<p>You can also use <code>calc()</code> with <a href="/en-US/docs/Web/CSS/CSS_Variables">CSS variables</a>. Consider the following code:</p>

<pre class="brush: css notranslate">.foo {
  --widthA: 100px;
  --widthB: calc(var(--widthA) / 2);
  --widthC: calc(var(--widthB) / 2);
  width: var(--widthC);
}</pre>

<p>After all variables are expanded, <code>widthC</code>'s value will be <code>calc( calc( 100px / 2) / 2)</code>, then when it's assigned to <code>.foo</code>'s width property, all inner <code>calc()</code>s (no matter how deeply nested) will be flattened to just parentheses, so the <code>width</code> property's value will be eventually <code>calc( ( 100px / 2) / 2)</code>, i.e. <code>25px</code>. In short: a <code>calc()</code> inside of a <code>calc()</code> is identical to just parentheses.</p>

<ul>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Values', '#calc-notation', 'calc()')}}</td>
   <td>{{Spec2('CSS3 Values')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.types.calc")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://hacks.mozilla.org/2010/06/css3-calc/">Firefox 4: CSS3 calc() ✩ Mozilla Hacks – the Web developer blog</a></li>
</ul>
